`timescale 1ns / 1ps

module testbench;
    reg C;                // Регистровая переменная для тактового сигнала
    reg reset;              // Регистровая переменная для сигнала сброса
    wire [3:0] Q;      // Подключение выхода счетчика

    // Инициализация счетчика
    counter uut (
        .C(C),
        .reset(reset),
        .Q(Q)
    );

    // Генерация синхросигнала сигнала
    initial begin
        C = 0;
        forever #5 C = ~C; // Переключение каждый 5 нс
    end

    // Тестирование счетчика
    initial begin
        // Сброс счетчика
        reset = 1;
        #10;
        reset = 0;

        // Ожидание счета
        #100;

        // Вывод текущего значения счетчика
        $display("Final Count: %b", Q);

        // Завершение симуляции
        $finish;
    end
endmodule