module reverse_counter (
    input wire C,         // Входной тактовый сигнал
    input wire R,       // Сигнал сброса
    input wire Cu, // Сигнал инкремента (если 1, увеличивает, если 0 — уменьшает)
	input wire Cd,
	input wire EN,
    output reg [3:0] Q  // 4-разрядный счетчик
);

    always @(posedge C or posedge R) begin
        if (R) begin
            Q <= 4'b0000; // Сброс счетчика
        end else if (EN && Cu && !Cd) begin
            Q <= Q + 1; // Увеличение счетчика на 1
        end else if (EN && !Cu && Cd) begin
            Q <= Q - 1; // Уменьшение счетчика на 1
        end else begin
			Q <= Q;
    end
end
endmodule