`timescale 1ns / 1ps

module testbench;
    reg C;                // Регистровая переменная для тактового сигнала
    reg R;              // Регистровая переменная для сигнала сброса
    reg Cu; // Регистровая переменная для сигнала инкремента
	reg Cd;
	reg EN;
    wire [3:0] Q;      // Подключение выхода счетчика

    // Инициализация реверсивного счетчика
    reverse_counter uut (
        .C(C),
        .R(R),
        .Cu(Cu),
		.Cd(Cd),
		.EN(EN),
        .Q(Q)
    );

    // Генерация тактового сигнала
    initial begin
       C = 0;
        forever #5 C = ~C; // Переключение каждые 5 нс
    end

    // Тестирование реверсивного счетчика
    initial begin
        // Инициализация
        R = 1;
        Cu = 1; // Увеличивание по умолчанию
		Cd = 0;
		EN=1;
        #10;
        R = 0;

        // Увеличиваем счетчик
        repeat (10) begin
            #10; // Ждем 10 нс
        end

        // Меняем режим работы на уменьшение
        Cu = 0;
		Cd=1;// Уменьшение счетчика
        repeat (10) begin
            #10; // Ждем 10 нс
        end

        // Завершение симуляции и вывод финального значения
        $display("Final Count: %b", Q);
        $finish;
    end
endmodule